/**
	P2PPacket:

	Author: Travis Desell
	LastModified: 9/20/2002
 */

package io.core.protocol;

import java.net.*; 
import java.io.*;
import java.util.Vector;
import io.core.messaging.TheaterLocator;

public class P2PPacket implements java.io.Serializable {

	private TheaterLocator origin;

	public void setOrigin(TheaterLocator _origin) {
		origin = _origin;
	}

	public TheaterLocator getOrigin() {
		return origin;
	}


	public void broadcast(Vector peerTheaters) {
		for (int i = 0; i < peerTheaters.size(); i++) {
			TheaterLocator theaterLocator = (TheaterLocator)peerTheaters.get(i);

			try {
				//Connect to the given Theater;
				Socket theaterConnection = new Socket(theaterLocator.getHost(), theaterLocator.getPort());
				ObjectOutputStream out = new ObjectOutputStream(new BufferedOutputStream(theaterConnection.getOutputStream()));

				//write the packet to the connection, then close it
				out.writeObject(this);
				out.flush();
				out.close();
				theaterConnection.close();
	
			} catch (UnknownHostException e) {
				System.err.println("Error sending information to server: "+theaterLocator.toString()+":"+e);
			} catch (IOException e) {
				System.err.println("Error sending information to server: "+theaterLocator.toString()+":"+e);
			}
		}
	}

	public void send(TheaterLocator theaterLocator) {
		try {
			//Connect to the given Theater;
			Socket theaterConnection = new Socket(theaterLocator.getHost(), theaterLocator.getPort());
			ObjectOutputStream out = new ObjectOutputStream(new BufferedOutputStream(theaterConnection.getOutputStream()));


			//write the packet to the connection, then close it
			out.writeObject(this);
			out.flush();
			out.close();
			theaterConnection.close();

		} catch (UnknownHostException e) {
			System.err.println("Error sending information to server: "+theaterLocator.toString()+":"+e);
		} catch (IOException e) {
			System.err.println("Error sending information to server: "+theaterLocator.toString()+":"+e);
		}
	}

}
