package io.random.messaging; 

import salsa.language.ServiceFactory;

import wwc.messaging.PersistentMessenger;

import io.core.messaging.PeerTheater;
import io.core.messaging.PersistentIOHandler;
import io.random.decision.RandomDecisionAgent;
import io.random.messaging.RandomHandler;
import io.random.messaging.RandomProtocolHandler;

public class RandomPeerTheater extends PeerTheater {

	private static RandomPeerTheater instance = new RandomPeerTheater();

	public RandomPeerTheater() {
		super();
	}

	public static PeerTheater getInstance() {
		return (PeerTheater)instance;
	}

	public static void main(String[] args) {
		ServiceFactory.createFactory(getInstance(), new PersistentMessenger(), new RandomHandler(), null);

		getInstance().decider = new RandomDecisionAgent();
		getInstance().protocolHandler = new RandomProtocolHandler();

		getInstance().initialize(args);

		getInstance().decider.start();
		getInstance().startTheater();
	}
}
